# xAPI-Spec

This Github repository contains the xAPI Specification. xAPI is a learning
technologies interoperability specification that describes communication
about learner activity and experiences between technologies. The specification is
divided into three documents:

*   Part One:   [About the Experience API](./xAPI-About.md#partone)
*   Part Two:   [Experience API Data](./xAPI-Data.md#parttwo)
*   Part Three: [Data Processing, Validation, and Security](./xAPI-Communication.md#partthree)

## Specification versions

The current version of the specification is
[1.0.3](https://github.com/adlnet/xAPI-Spec/).

The next version of the specification has not been planned. 

## What to do if the spec is unclear

If when implementing the specification you find something is unclear or
unhelpful, you can help to improve the specification by
[raising an issue here](https://github.com/adlnet/xAPI-Spec/issues). When
raising an issue, please give as much detail as you can in regards to:

* Which part/parts of the specification you are reading.
* Your understanding of what these parts mean.
* The product and feature you are implementing xAPI in; what's the use case you
  are trying to achieve?
* How you would like the specification to be improved. Suggest some specific new
  wording if you like!

You'll need to [sign up for a GitHub account](https://github.com/signup/free) if
you do not already have one in order to raise and comment on issues.

You can discuss any issues before or after raising them on the
[specification Google Group](https://groups.google.com/a/adlnet.gov/forum/#!forum/xapi-spec)
and at our
[weekly specification calls](https://attendee.gotowebinar.com/register/7730918418468686596).

## How you can contribute

You'll need to [sign up for a GitHub account](https://github.com/signup/free) if
you do not already have one in order to contribute to the specification.

The xAPI Spec Working Group meets
the first, second, and third Wednesdays of each month on GoToWebinar. You can register at [https://attendee.gotowebinar.com/register/7730918418468686596](https://attendee.gotowebinar.com/register/7730918418468686596)

Please refer to the [Contribution guidelines](CONTRIBUTING.md) for further direction and a list of contributors.